/*
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software donated to Berkeley by
 * Jan-Simon Pendry.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)null.h	8.3 (Berkeley) 8/20/94
 *
 * $Id: lgfs.h,v 1.3 1999/07/09 00:50:34 kpreslan Exp $
 */
#ifndef __LGFS__
#define __LGFS__

#include "gfs_mount.h"

struct gfs_mount {
	struct mount	*gfsm_vfs;
	struct vnode	*gfsm_rootvp;	/* Reference to root gfs_node */
};

#ifdef KERNEL
/*
 * A cache of vnode references
 */
struct gfs_node {
	LIST_ENTRY(gfs_node)	gfs_hash;	/* Hash list */
	struct vnode	        *gfs_lowervp;	/* VREFed once */
	struct vnode		    *gfs_vnode;	/* Back pointer */
};

extern int gfs_init __P((struct vfsconf *vfsp));
extern int gfs_node_create __P((struct mount *mp, struct vnode *target, struct vnode **vpp));

#define	MOUNTTOGFSMOUNT(mp) ((struct gfs_mount *)((mp)->mnt_data))
#define	VTOGFS(vp) ((struct gfs_node *)(vp)->v_data)
#define	GFSTOV(xp) ((xp)->gfs_vnode)
#ifdef GFS_DIAGNOSTIC
extern struct vnode *gfs_checkvp __P((struct vnode *vp, char *fil, int lno));
#define	GFSVPTOLOWERVP(vp) gfs_checkvp((vp), __FILE__, __LINE__)
#else
#define	GFSVPTOLOWERVP(vp) (VTOGFS(vp)->gfs_lowervp)
#endif

extern int	gfs_bypass __P((struct vop_generic_args *ap));

extern vop_t **gfs_vnodeop_p;

#endif /* KERNEL */
#endif /* LGFS */
