/******************************************************************************
*******************************************************************************
**
**    Portions Copyright 1999 Sistina Software, Inc.  <kpreslan@sistina.com>
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth W. Preslan <kpreslan@lcse.umn.edu>
** 
**    Module name: mount.c
**
*******************************************************************************
******************************************************************************/

#include "gfs.h"
#include "gfs_mount.h"
#include "mount_linux.h"



/******************************************************************************
*******************************************************************************
**
** gfs_make_args()
**
** Description:
**
** Input(s):
**
** Output(s):
**
** Returns:
**
*******************************************************************************
******************************************************************************/

void gfs_make_args(char *data, gfs_args_t *args)
{
  char *p = NULL, *t = NULL, *h = NULL;
  int x;


  memset(args, 0, sizeof(gfs_args_t));


  if (data)
  {
    p = strstr(data, "lockproto=");
    t = strstr(data, "locktable=");
    h = strstr(data, "hostdata=");
  }


  /*  Figure out the Locking Protocol name  */

  if (p)
  {
    while (*p++ != '=') ;

    x = 0;
    while (*p && *p != ',' && *p != ' ' && x < 255)
      args->lockproto[x++] = *p++;
    args->lockproto[x] = 0;
  }


  /*  Figure out the Lock Table name  */

  if (t)
  {
    while (*t++ != '=') ;

    x = 0;
    while (*t && *t != ',' && *t != ' ' && x < 255)
      args->locktable[x++] = *t++;
    args->locktable[x] = 0;
  }


  /*  Figure out the Host Data field  */

  if (h)
  {
    while (*h++ != '=') ;

    x = 0;
    while (*h && *h != ',' && *h != ' ' && x < 255)
      args->hostdata[x++] = *h++;
    args->hostdata[x] = 0;
  }
}



