/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth Preslan <kpreslan@lcse.umn.edu>
** 
**    Module name:  bmap.h
**
*******************************************************************************
******************************************************************************/

#ifndef __BMAP_DOT_H__
#define __BMAP_DOT_H__


#define GFS_BMAP_STUFFED_DINODE    (0x00000010)
#define GFS_BMAP_HOLE              (0x00000020)
#define GFS_BMAP_NEW               (0x00000040)
#define GFS_BMAP_READA             (0x00000080)


typedef struct gfs_direct_s
{
  int                 dr_num;           /* Number of direct_t structures in this array */
  int                 dr_flags;         /* Flags about this block mapping */
  uint64              dr_no;            /* FS Block number */
  int                 dr_start;         /* Starting byte in block */
  int                 dr_len;           /* Length in bytes of area to be transfered */
} gfs_direct_t;



int gfs_unstuff_dinode(gfs_inode_t *ip);
int gfs_bmapi_read(gfs_inode_t *ip, uint64 offset, uint64 size, gfs_direct_t **direct);
int gfs_bmapi_write(gfs_inode_t *ip, uint64 offset, uint64 size, gfs_direct_t **direct);


#endif  /*  __BMAP_DOT_H__  */
