/******************************************************************************
*******************************************************************************
**
**    Copyright 1999 Sistina Software, Inc.  <kpreslan@sistina.com>
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth W. Preslan <kpreslan@sistina.com>
** 
**    Module name: gfs_mount.h
**
**    Description:
**	Defines the structure that holds the mount parameters
**
*******************************************************************************
******************************************************************************/

#ifndef GFS_MOUNT_DOT_H
#define GFS_MOUNT_DOT_H


typedef struct gfs_args_s
{
  char	    *target;           /*  The device the FS is mounted on  */
  char      lockproto[256];    /*  The name of the Lock Protocol  */
  char      locktable[256];    /*  The name of the Lock Table  */
  char      hostdata[256];     /*  The host specific data  */
} gfs_args_t;


#endif  /*  GFS_MOUNT_DOT_H  */


