/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      David C. Teigland  <teigland@lcse.umn.edu>
** 
**    Module name: assemble.h
**
**    Description:
**	Network storage pool assembler routines.
**
*******************************************************************************
******************************************************************************/

#ifndef __ASSEMBLE_H__
#define __ASSEMBLE_H__

#include "pool.h"


#define SEARCH_DIR	"/dev/"
#define makedevice	MKDEV

#define AS_VERBOSE	0x00001
#define	AS_FORCE	0x00002
#define AS_REMOVE	0x00004
#define AS_DESTROY	0x00008


typedef struct label_list_s
{
  int		l_cnt;
  pool_label_t	*l_lbs;		/* list of actual labels read off disk */
  dev_t		*l_devs;	/* devices for labels */
} label_list_t;



void printUsage(char *progName, int status);
int scan_partitions(char *path);
int scan_label(int fd, char *devName);
int create_pool(pool_add_t **pool);
int remove_pools(pool_list_t *list, int commfd, char *name);
int printLabels(pool_add_t *pool);
int clean_dir(int commfd);
int pool_list(pool_list_t *inuse_list, int commfd);
int getdevnum(char *path, dev_t *devnum);
int skip_pool(pool_add_t **pool, pool_list_t *list);
int check_name(pool_add_t **pool, pool_list_t *list);
int free_mem(pool_add_t *pool);
int skip_md_devs(char *dev);

extern void pool_label_in(pool_label_t *pl, char *buf);
  
#endif /* __ASSEMBLE_H_ */















