#ifndef __DTYPES_H__
#define __DTYPES_H__

#include <rpc/rpc.h>


typedef u_int u32;
#ifdef __cplusplus 
extern "C" bool_t xdr_u32(XDR *, u32*);
#elif __STDC__ 
extern  bool_t xdr_u32(XDR *, u32*);
#else /* Old Style C */ 
bool_t xdr_u32();
#endif /* Old Style C */ 


typedef u_short u16;
#ifdef __cplusplus 
extern "C" bool_t xdr_u16(XDR *, u16*);
#elif __STDC__ 
extern  bool_t xdr_u16(XDR *, u16*);
#else /* Old Style C */ 
bool_t xdr_u16();
#endif /* Old Style C */ 


typedef u_char u8;
#ifdef __cplusplus 
extern "C" bool_t xdr_u8(XDR *, u8*);
#elif __STDC__ 
extern  bool_t xdr_u8(XDR *, u8*);
#else /* Old Style C */ 
bool_t xdr_u8();
#endif /* Old Style C */ 


struct dlock_CDB {
	u8 opcode;
	u8 action;
	u32 lock_number;
	u8 input_version_number;
	u32 allocation_length;
	u32 cid;
};

typedef struct dlock_CDB dlock_CDB;
#ifdef __cplusplus 
extern "C" bool_t xdr_dlock_CDB(XDR *, dlock_CDB*);
#elif __STDC__ 
extern  bool_t xdr_dlock_CDB(XDR *, dlock_CDB*);
#else /* Old Style C */ 
bool_t xdr_dlock_CDB();
#endif /* Old Style C */ 


struct mode_CDB {
	u8 tag;
	u8 max_clients;
	u32 num_locks;
	u32 lock_time_ms;
};

typedef struct mode_CDB mode_CDB;
#ifdef __cplusplus 
extern "C" bool_t xdr_mode_CDB(XDR *, mode_CDB*);
#elif __STDC__ 
extern  bool_t xdr_mode_CDB(XDR *, mode_CDB*);
#else /* Old Style C */ 
bool_t xdr_mode_CDB();
#endif /* Old Style C */ 


struct CDBs {
	int type;
	union {
		struct dlock_CDB dlock;
		struct mode_CDB mode;
	} CDBs_u;
};
typedef struct CDBs CDBs;
#ifdef __cplusplus 
extern "C" bool_t xdr_CDBs(XDR *, CDBs*);
#elif __STDC__ 
extern  bool_t xdr_CDBs(XDR *, CDBs*);
#else /* Old Style C */ 
bool_t xdr_CDBs();
#endif /* Old Style C */ 


struct cid_ntry {
	struct cid_ntry *next;
	u32 cid;
};

typedef struct cid_ntry cid_ntry;
#ifdef __cplusplus 
extern "C" bool_t xdr_cid_ntry(XDR *, cid_ntry*);
#elif __STDC__ 
extern  bool_t xdr_cid_ntry(XDR *, cid_ntry*);
#else /* Old Style C */ 
bool_t xdr_cid_ntry();
#endif /* Old Style C */ 


struct dlock_RDF {
	u8 result;
	u8 act;
	u8 expired;
	u8 state;
	u32 version_number;
	u8 num_holders;
	struct cid_ntry *head;
};

typedef struct dlock_RDF dlock_RDF;
#ifdef __cplusplus 
extern "C" bool_t xdr_dlock_RDF(XDR *, dlock_RDF*);
#elif __STDC__ 
extern  bool_t xdr_dlock_RDF(XDR *, dlock_RDF*);
#else /* Old Style C */ 
bool_t xdr_dlock_RDF();
#endif /* Old Style C */ 


struct rexpired_RDF {
	u16 return_length;
	u8 *exlock_block;
};

typedef struct rexpired_RDF rexpired_RDF;
#ifdef __cplusplus 
extern "C" bool_t xdr_rexpired_RDF(XDR *, rexpired_RDF*);
#elif __STDC__ 
extern  bool_t xdr_rexpired_RDF(XDR *, rexpired_RDF*);
#else /* Old Style C */ 
bool_t xdr_rexpired_RDF();
#endif /* Old Style C */ 


struct mode_page_RDF {
	u32 num_locks;
	u8 max_clients;
	u32 lock_time_ms;
};

typedef struct mode_page_RDF mode_page_RDF;
#ifdef __cplusplus 
extern "C" bool_t xdr_mode_page_RDF(XDR *, mode_page_RDF*);
#elif __STDC__ 
extern  bool_t xdr_mode_page_RDF(XDR *, mode_page_RDF*);
#else /* Old Style C */ 
bool_t xdr_mode_page_RDF();
#endif /* Old Style C */ 


struct RDFs {
	int type;
	union {
		struct dlock_RDF dlock;
		struct rexpired_RDF rex;
		struct mode_page_RDF mpag;
	} RDFs_u;
};

typedef struct RDFs RDFs;
#ifdef __cplusplus 
extern "C" bool_t xdr_RDFs(XDR *, RDFs*);
#elif __STDC__ 
extern  bool_t xdr_RDFs(XDR *, RDFs*);
#else /* Old Style C */ 
bool_t xdr_RDFs();
#endif /* Old Style C */ 

#endif /*__DTYPES_H__*/
