/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Andrew Barry <barry@lcse.umn.edu>
** 
**    Module name: mode_page.h
**
*******************************************************************************
******************************************************************************/


#ifndef __MODE_PAGE_H__
#define __MODE_PAGE_H__


#include "global.h"
#include <stdlib.h>
#include <stdio.h>
#include "dtypes.h"


rexpired_rdf    *new_rexpired_rdf(int numlocks);
mode_page       *new_mode_cdb();
mode_page       *new_mode_page_rdf();

void delete_mode_page      (mode_page *mp);
void delete_rexpired_rdf   (rexpired_rdf *rdf);

/*********************************************************
 *********************************************************
 **get_exlock_block()
 **
 **Description: an exlock block is a 1 byte feild holding 
 **a bitmap of eight lock's expired status. this returns 
 **the block in which the input lock is stored. 
 *********************************************************
 *********************************************************/
uint8 *get_exlock_block    (rexpired_rdf *rdf, int lock);

/*********************************************************
 *********************************************************
 **re_rdf_set_exlock()
 **
 **Description: sets the bit for the input lock in the input
 **rexpired_rdf.
 *********************************************************
 *********************************************************/
void re_rdf_set_exlock     (rexpired_rdf *rdf, int lock);

/*********************************************************
 *********************************************************
 **re_rdf_clear_exlock()
 **
 **Description: clears the bit for the input lock in the input
 **rexpired_rdf.
 *********************************************************
 *********************************************************/
void re_rdf_clear_exlock   (rexpired_rdf *rdf, int lock);




#endif /* __MODE_PAGE_H__ */


