/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Andrew Barry <barry@lcse.umn.edu>
** 
**    Module name: print.h
**
*******************************************************************************
******************************************************************************/


#ifndef __PRINT_H__
#define __PRINT_H__

#include "partition.h"
#include "mode_page.h"
#include <stdio.h>

/*********************************************************
 *********************************************************
 **print_server_dlock()
 **
 **Description: prints the most relevant information about
 **the input server dlock. uses dbprintf, which is void 
 **unless compiled with the -VERBOSE flag. 
 *********************************************************
 *********************************************************/
void print_server_dlock(server_dlock *sdl);

/*********************************************************
 *********************************************************
 **print_partition_locks()
 **
 **Description: prints the most relevant information about
 **the input partition locks. uses dbprintf, which is void 
 **unless compiled with the -VERBOSE flag. 
 *********************************************************
 *********************************************************/
void print_partition_locks(partition_locks *pal);

/*********************************************************
 *********************************************************
 **print_rexpired_RDF()
 **
 **Description: prints the most relevant information about
 **the input rexpired_RDF. uses dbprintf, which is void 
 **unless compiled with the -VERBOSE flag. 
 *********************************************************
 *********************************************************/
void print_rexpired_RDF(rexpired_rdf *rdf);

/*********************************************************
 *********************************************************
 **print_dlock_cdb()
 **
 **Description: prints the most relevant information about
 **the input dlock_cdb. uses dbprintf, which is void 
 **unless compiled with the -VERBOSE flag. 
 *********************************************************
 *********************************************************/
void print_dlock_cdb(dlock_cdb *cdb);

/*********************************************************
 *********************************************************
 **print_dlock_rdf()
 **
 **Description: prints the most relevant information about
 **the input dlock_rdf. uses dbprintf, which is void 
 **unless compiled with the -VERBOSE flag. 
 *********************************************************
 *********************************************************/
void print_dlock_rdf(dlock_rdf *rdf);


#endif
